' Beispiel fr Jump'n Run-Spiel mit animiertem Sprite

' (c) 2000 by Andreas Meile, CH-8242 Hofen SH

DECLARE SUB AktualisiereTasten ()
DECLARE SUB ErzeugeANDMaske (Bild%(), Maske%(), s%)

' Auszug aus BMP_LIB
DECLARE SUB LadeBild (dn$, f%(), ind%)
DECLARE SUB LadePalette (dn$, p&(), ind%, mo%)
CONST PalCGA% = 0   ' fr SCREEN 1/2/7/8
CONST PalEGA% = 1   ' fr SCREEN 0/9
CONST PalVGA% = 2   ' fr SCREEN 11/12/13
CONST PalVlf% = 3

' Tasten-Scancodes
CONST PfeilLinks% = 75
CONST PfeilRechts% = 77
CONST Leertaste% = 57
CONST Esc% = 1

DIM globPal&(15), baum%(1079), mann%(3663), mauer%(489)
DIM baumMsk%(1079), mannMsk%(3663), mauerMsk%(489)
DIM TransPu%(2000)

DIM SHARED TasteGedr%(127)
FOR i% = 0 TO 127
  TasteGedr%(i%) = 0
NEXT i%

' Bilder und Sprites mit Farbpaletten laden
PRINT "Einen Moment, lade Bilder..."
LadePalette "baum", globPal&(), LBOUND(globPal&), PalCGA%
LadeBild "baum", baum%(), LBOUND(baum%)
LadeBild "mauer", mauer%(), LBOUND(mauer%)
h% = 0
FOR i% = 4 TO 1 STEP -1
  LadeBild "mann_l" + CHR$(48 + i%), mann%(), h%
NEXT i%
FOR i% = 1 TO 4
  LadeBild "mann_r" + CHR$(48 + i%), mann%(), h%
NEXT i%

SCREEN 7
' AND-Masken vorbereiten
ErzeugeANDMaske baum%(), baumMsk%(), LBOUND(baum%)
ErzeugeANDMaske mauer%(), mauerMsk%(), LBOUND(mauer%)
FOR i% = 0 TO 7
  ErzeugeANDMaske mann%(), mannMsk%(), i% * 458
NEXT i%

' Landschaft zeichnen
LINE (0, 0)-(319, 199), 1, BF
PALETTE USING globPal&
LINE (0, 100)-(319, 199), 2, BF
LINE (0, 120)-(319, 157), 8, BF
LINE (0, 124)-(319, 126), 7, BF
FOR i% = 2 TO 360 STEP 29
  LINE (i% + 3, 120)-(i%, 124), 7
  LINE -(i%, 126), 8
NEXT i%

' Hintergrundkulisse: Diese erscheint wie die Strasse hinter dem Mann
PUT (12, 90), mauerMsk%, AND
PUT (12, 90), mauer%, XOR
FOR i% = 50 TO 230 STEP 90
  PUT (i%, 40), baumMsk%, AND
  PUT (i%, 40), baum%, XOR
NEXT i%

' Vordergrundkulisse: Hinter dieser spaziert unser Mann durch :-)
FOR b% = 0 TO 1
  GOSUB ZeichneBaum
NEXT b%
GOSUB ZeichneRechteMauer

PCOPY 0, 1
PCOPY 0, 2
' Ab hier Spiel :-)
xM% = 100
yM% = 89
xMAlt% = xM%
yMAlt% = yM%
ri% = 4       ' Blickrichtung Spieler
r1% = 0       ' Laufrichtung
r1Alt% = 0
LeertAlt% = 0
SprStat% = 0
FigSt0% = 0
xPo0! = CSNG(xM%)

' TRoh! : Zeitgltter, um den groben Takt von nur 18.2 Clocks/Sek der
' Systemuhr auszugltten => ergibt schnere Animationen
DIM TRoh!(15)
tk! = TIMER + 30!
ts! = 0!
FOR i% = 0 TO 15
  TRoh!(i%) = TIMER - tk!
  ts! = ts! + TRoh!(i%)
NEXT i%
AktZeit! = TIMER - tk!

WHILE NOT TasteGedr%(Esc%)
  ' Tiefpassfilter Zeit
  t1! = TIMER - tk!
  AktZeit! = AktZeit! + (16! * t1! - ts!) / 136!
  ts! = ts! - TRoh!(sc%) + t1!
  TRoh!(sc%) = t1!
  sc% = sc% + 1 AND 15

  ' Altes Sprite lschen: bermalen mit ursprnglichem Bild
  SCREEN , , 2, 0
  GET (xMAlt%, yMAlt%)-STEP(26, 56), TransPu%
  SCREEN , , 1, 0
  PUT (xMAlt%, yMAlt%), TransPu%, PSET
  ' Neue Stellung des Mannes zeichnen
  PUT (xM%, yM%), mannMsk%(458 * (ri% + FigSt%)), AND
  PUT (xM%, yM%), mann%(458 * (ri% + FigSt%)), XOR
  ' Vordergrund nur bei Bedarf nachzeichnen
  IF xM% > 253 THEN
    GOSUB ZeichneRechteMauer
  END IF
  FOR b% = 0 TO 1
    IF xM% > 90 * b% + 53 AND xM% < 90 * b% + 131 THEN
      GOSUB ZeichneBaum
    END IF
  NEXT b%
  ' Ausschnitt von der Vorbereitungs-Bildschirmseite auf die vordergrndig
  ' sichtbare Seite bertragen; nur so wenig wie mglich bertragen
  IF xM% < xMAlt% THEN
    xM1% = xM%
    xM2% = xMAlt% + 26
  ELSE
    xM1% = xMAlt%
    xM2% = xM% + 26
  END IF
  IF yM% < yMAlt% THEN
    yM1% = yM%
    yM2% = yMAlt% + 56
  ELSE
    yM1% = yMAlt%
    yM2% = yM% + 56
  END IF
  GET (xM1%, yM1%)-(xM2%, yM2%), TransPu%
  SCREEN , , 0, 0
  PUT (xM1%, yM1%), TransPu%, PSET
  xMAlt% = xM%
  yMAlt% = yM%
  AktualisiereTasten
  ' Laufrichtung auswerten
  r1% = TasteGedr%(PfeilLinks%) - TasteGedr%(PfeilRechts%)
  IF r1% <> r1Alt% THEN
    ' nderung gegenber letztes Mal
    v! = CSNG(r1%) * 40!
    t0x! = AktZeit
    xPo0! = CSNG(xM%)
    SELECT CASE r1%
    CASE 1
      IF ri% <> 4 THEN
        ri% = 4
        FigSt0% = 2
      END IF
    CASE -1
      IF ri% <> 0 THEN
        ri% = 0
        FigSt0% = 2
      END IF
    CASE 0
      FigSt0% = FigSt%
    END SELECT
    r1Alt% = r1%
  END IF
  ' Aktuelle Spielerposition zur momentanen Zeit berechnen
  ' mit Geschwindigkeitsformel aus Physik
  dt! = AktZeit - t0x!
  xPo! = xPo0! + dt! * v!
  IF xPo! < 32! THEN
    xM% = 32
    xPo0! = 32!
    v! = 0!
  ELSEIF xPo! > 263! THEN
    xM% = 263
    xPo0! = 263!
    v! = 0!
  ELSE
    xM% = CINT(xPo!)
  END IF
  IF r1% <> 0 THEN
    FigSt% = CINT(dt! * 12!) + FigSt0% AND 3
  END IF

  ' Sprung auswerten
  ' Bedeutung Sprungstatus: 0=am Boden, 1=zum Sprung ansetzend, 2=in der Luft
  IF SprStat% = 2 THEN
    t! = AktZeit - t0!
    ' Beschleunigungsformel aus Physik
    yPo! = t! * (t! * 200! - vy0!) + 89!
    IF yPo! > 89! THEN
      yM% = 89
      IF TasteGedr%(Leertaste%) THEN
        t0Sprungkr! = AktZeit
        SprStat% = 1  ' Erneut zum Sprung ansetzen
      ELSE
        SprStat% = 0
      END IF
    ELSE
      yM% = CINT(yPo!)
    END IF
  ELSE
    IF TasteGedr%(Leertaste%) AND NOT LeertAlt% THEN
      ' Leertaste wurde soeben heruntergedrckt
      t0Sprungkr! = AktZeit
      SprStat% = 1  ' Zum Sprung ansetzen
    ELSEIF NOT TasteGedr%(Leertaste%) AND LeertAlt% THEN
      ' Leertaste wurde soeben wieder losgelassen
      IF SprStat% = 1 THEN
        vy0! = 800! * (AktZeit - t0Sprungkr!)
        t0! = AktZeit
        SprStat% = 2
      END IF
    END IF
    IF SprStat% = 1 AND AktZeit - t0Sprungkr! >= .2 THEN
      ' Lse Sprung sptestens nach 200 Millisekunden aus
      vy0! = 160!
      t0! = t0Sprungkr! + .2
      SprStat% = 2
    END IF
  END IF
  LeertAlt% = TasteGedr%(Leertaste%)
WEND

SCREEN 0
WIDTH 80, 25
END

ZeichneBaum:
PUT (90 * b% + 80, 100), baumMsk%, AND
PUT (90 * b% + 80, 100), baum%, XOR
RETURN

ZeichneRechteMauer:
PUT (280, 90), mauerMsk%, AND
PUT (280, 90), mauer%, XOR
RETURN

SUB AktualisiereTasten
  cAlt% = -1
  WHILE c% <> cAlt%
    cAlt% = c%
    c% = INP(96)
    TasteGedr%(c% AND 127) = (c% AND 128) = 0
  WEND
  WHILE INKEY$ <> "": WEND
END SUB

SUB ErzeugeANDMaske (Bild%(), Maske%(), s%)
  xb% = Bild%(s%)
  yb% = Bild%(s% + 1)
  PUT (0, 0), Bild%(s%), PSET
  FOR y% = 0 TO yb% - 1
    FOR x% = 0 TO xb% - 1
      PSET (x%, y%), (POINT(x%, y%) = 1) AND 15
    NEXT x%
  NEXT y%
  GET (0, 0)-(xb% - 1, yb% - 1), Maske%(s%)
  PUT (0, 0), Bild%(s%), PSET
  FOR y% = 0 TO yb% - 1
    FOR x% = 0 TO xb% - 1
      IF POINT(x%, y%) = 1 THEN
        PSET (x%, y%), 0
      END IF
    NEXT x%
  NEXT y%
  GET (0, 0)-(xb% - 1, yb% - 1), Bild%(s%)
END SUB

SUB LadeBild (dn$, f%(), ind%)
  OPEN dn$ + ".BMP" FOR INPUT AS 1
  CLOSE 1
  OPEN dn$ + ".BMP" FOR BINARY AS 1
  k$ = INPUT$(2, 1)
  IF k$ <> "BM" THEN
    PRINT "Kein gltiges Windows Bitmap Bild!"
    ERROR 5
  END IF
  SEEK 1, 11&
  basOf& = CVL(INPUT$(4, 1)) + 1&  ' ab hier beginnen die Nutzdaten
  SEEK 1, 19&
  xb& = CVL(INPUT$(4, 1))  ' Bildgrsse
  yb& = CVL(INPUT$(4, 1))
  anzBpl% = CVI(INPUT$(2, 1))
  IF anzBpl% <> 1 THEN
    PRINT "Bildformat einer knftigen Windowsversion"
    ERROR 5
  END IF
  bpp% = CVI(INPUT$(2, 1))
  komp& = CVL(INPUT$(4, 1))
  IF komp& <> 0& THEN
    PRINT "Komprimierung nicht untersttzt"
    ERROR 5
  END IF
  ' Start der Verarbeitung
  br& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
  IF bpp% = 8 THEN
    f%(ind%) = 8 * CINT(xb&)
  ELSE
    f%(ind%) = CINT(xb&)
  END IF
  f%(ind% + 1) = CINT(yb&)
  ind% = ind% + 2
  SELECT CASE bpp%
  CASE 1, 8
    IF bpp% = 1 THEN
      b% = CINT((xb& + 7&) \ 8&)
    ELSE
      b% = CINT(xb&)
    END IF
    Pu$ = ""
    FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
      SEEK 1, y&
      FOR x% = 1 TO b%
        Pu$ = Pu$ + INPUT$(1, 1)
        IF LEN(Pu$) = 2 THEN
          f%(ind%) = CVI(Pu$)
          ind% = ind% + 1
          Pu$ = ""
        END IF
      NEXT x%
    NEXT y&
    IF Pu$ <> "" THEN
      f%(ind%) = CVI(Pu$ + " ")
      ind% = ind% + 1
    END IF
  CASE 4
    DIM h%(3)
    FOR i% = 0 TO 3
      h%(i%) = 0
    NEXT i%
    b% = CINT(br&) \ 4
    pu1$ = SPACE$(4 * b%)
    FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
      SEEK 1, y&
      FOR x1% = 1 TO b%
        FOR x2% = 1 TO 4
          z% = ASC(INPUT$(1, 1))
          FOR x3% = 0 TO 3
            h%(x3%) = 4 * h%(x3%) + (z% AND 1) + (z% AND 16) \ 8
            z% = z% \ 2
          NEXT x3%
        NEXT x2%
        FOR i% = 0 TO 3
          MID$(pu1$, x1% + b% * i%) = CHR$(h%(i%))
          h%(i%) = 0
        NEXT i%
      NEXT x1%
      FOR i% = 1 TO LEN(pu1$) STEP 2
        f%(ind%) = CVI(MID$(pu1$, i%, 2))
        ind% = ind% + 1
      NEXT i%
    NEXT y&
  CASE 24
    PRINT "Echtfarb (True Color) nicht mglich"
    ERROR 5
  CASE ELSE
    PRINT "Unbekannte Bildtiefe"
    ERROR 5
  END SELECT
  CLOSE 1
END SUB

SUB LadePalette (dn$, p&(), ind%, mo%)
  OPEN dn$ + ".BMP" FOR INPUT AS 1
  CLOSE 1
  OPEN dn$ + ".BMP" FOR BINARY AS 1
  k$ = INPUT$(2, 1)
  IF k$ <> "BM" THEN
    PRINT "Kein gltiges Windows Bitmap Bild!"
    ERROR 5
  END IF
  SEEK 1, 15&
  palOf& = CVL(INPUT$(4, 1)) + 15&   ' ab hier beginnen die Farbeintrge
  SEEK 1, 27&
  anzBpl% = CVI(INPUT$(2, 1))
  IF anzBpl% <> 1 THEN
    PRINT "Bildformat einer knftigen Windowsversion"
    ERROR 5
  END IF
  bpp% = CVI(INPUT$(2, 1))
  IF bpp% > 12 THEN
    PRINT "Echtfarb verwendet keine Farbpalette"
    ERROR 5
  END IF
  ' Start der Verarbeitung
  aF% = 1
  FOR i% = 1 TO bpp%
    aF% = aF% * 2
  NEXT i%
  IF mo% = PalVlf% THEN
    ' verlustfreier Spezialmodus, der keinem SCREEN gehrt
    ' liest gesamter RGBQUAD ein
    SEEK 1, palOf&
    FOR i% = 1 TO aF&
      p&(ind%) = CVL(INPUT$(4, 1))
      ind% = ind% + 1
    NEXT i%
  ELSE
    FOR i% = 1 TO aF%
      SEEK 1, palOf&
      b% = ASC(INPUT$(1, 1))
      g% = ASC(INPUT$(1, 1))
      r% = ASC(INPUT$(1, 1))
      SELECT CASE mo%
      CASE PalCGA%  ' CGA-Palette von SCREEN 1/2/7/8
        Cga% = (r% AND 128) \ 32 + (g% AND 128) \ 64 + (b% AND 128) \ 128
        ' Selektion, ob hellerer oder dnklerer Farbton darstellen
        h% = (r% AND 127) + (g% AND 127) + (b% AND 127) - 192
        p&(ind%) = CLNG(Cga% - 8 * (h% > 0))
        IF p&(ind%) = 4 AND g% > 80 THEN
          p&(ind%) = 6   ' Spezialfall Orange
        END IF
      CASE PalEGA%  ' EGA-Palette von SCREEN 0/9
        p&(ind%) = CLNG((r% AND 64) \ 2 + (r% AND 128) \ 32 + (g% AND 64) \ 4 + (g% AND 128) \ 64 + (b% AND 64) \ 8 + (b% AND 128) \ 128)
      CASE PalVGA%  ' VGA-Palette von SCREEN 11/12/13
        p&(ind%) = CLNG(r% AND 252) \ 4& + CLNG(g% AND 252) * 64& + CLNG(b% AND 252) * 16384&
      CASE ELSE
        ERROR 5
      END SELECT
      palOf& = palOf& + 4&
      ind% = ind% + 1
    NEXT i%
  END IF
  CLOSE 1
END SUB

